From 6c1da1d5524fed7742005184559377c40b23afa9 Mon Sep 17 00:00:00 2001
From: md_5 <md_5@bigpond.com>
Date: Thu, 8 Nov 2012 18:57:44 +1100
Subject: [PATCH] Set a players sleeping ignored status synchronously, just in
 case! Thanks for the hint mbaxter & Wolvereness. Closes ticket 3179.

---
 .../essentials/EssentialsPlayerListener.java  | 19 ++++++++++++++-----
 1 file changed, 14 insertions(+), 5 deletions(-)

diff --git a/Essentials/src/com/earth2me/essentials/EssentialsPlayerListener.java b/Essentials/src/com/earth2me/essentials/EssentialsPlayerListener.java
index 22b164985..ae024da9c 100644
--- a/Essentials/src/com/earth2me/essentials/EssentialsPlayerListener.java
+++ b/Essentials/src/com/earth2me/essentials/EssentialsPlayerListener.java
@@ -166,7 +166,8 @@ public class EssentialsPlayerListener implements Listener
 			for (String p : ess.getVanishedPlayers())
 			{
 				Player toVanish = ess.getUser(p).getBase();
-				if (toVanish.isOnline()) {
+				if (toVanish.isOnline())
+				{
 					user.hidePlayer(toVanish);
 				}
 			}
@@ -174,7 +175,14 @@ public class EssentialsPlayerListener implements Listener
 
 		if (user.isAuthorized("essentials.sleepingignored"))
 		{
-			user.setSleepingIgnored(true);
+			ess.scheduleSyncDelayedTask(new Runnable()
+			{
+				@Override
+				public void run()
+				{
+					user.setSleepingIgnored(true);
+				}
+			});
 		}
 
 		if (!ess.getSettings().isCommandDisabled("motd") && user.isAuthorized("essentials.motd"))
@@ -356,9 +364,10 @@ public class EssentialsPlayerListener implements Listener
 	public void onPlayerChangedWorldHack(final PlayerChangedWorldEvent event)
 	{
 		final Player user = event.getPlayer();
-		if (user.getGameMode() != GameMode.CREATIVE) {
-			user.setAllowFlight(false);	
-		}		
+		if (user.getGameMode() != GameMode.CREATIVE)
+		{
+			user.setAllowFlight(false);
+		}
 		user.setFlySpeed(0.1f);
 		user.setWalkSpeed(0.2f);
 	}
